<template>
    <NuxtLayout :name="'dashboard'">
        <div class="p-8 w-screen bg-contain bg-center" style="background-image: url('/assets/img/auth/banner.jpg');">
            <!-- <Toast :visible="toastVisible" :title="toastTitle" :message="toastMessage" /> -->
            <CustomTable :tableName="tableName" :currentPage="currentPage" :limitPerPage="itemPerPage" :heads="heads"
                :items="files" :addPath="isAdmin ? '/standarizes/new' : ''" @on-search="search"
                @download-file="downloadFile" @delete-file="deleteFile" @page-change="pageUpdate" @sort-by="sortDataBy" />
        </div>
    </NuxtLayout>
</template>

<script lang="ts">

definePageMeta({
    middleware: ["auth"],
});

interface HeadInterface {
    key?: string;
    name: string;
    sort?: string;
}

export default {
    layout: "dashboard",
    data() {
        return {
            toastVisible: false,
            toastTitle: "",
            toastMessage: "",
            tableName: "Files",
            isLoading: false,
            currentPage: 1,
            itemPerPage: 10,
            heads: [
                {
                    "name": "No",
                },
                {
                    "key": "title",
                    "name": "Title",
                    "sort": ""
                },
                {
                    "key": "description",
                    "name": "Description",
                    "sort": ""
                },
                {
                    "key": "date",
                    "name": "Created At",
                    "sort": ""
                },
                {
                    "key": "owner_name",
                    "name": "Owner Name",
                    "sort": ""
                },
                {
                    "key": "owner_email",
                    "name": "Owner Email",
                    "sort": ""
                },
                {
                    "name": "Action",
                },
            ] as HeadInterface[],
            files: [],
        };
    },
    mounted() {
        this.fetchData();
    },
    computed: {
        isAdmin: () => {
            const userStore = useUserDataStore();
            return userStore.role === 'admin' ? true : false;
        }
    },
    methods: {
        fetchData(query: string = '') {
            this.isLoading = true;
            const toastStore = useToastStore();
            const config = useRuntimeConfig();
            this.$api
                .get(`/standarize?search=${query}&page=${this.currentPage}&limit=${this.itemPerPage}`, {
                    headers: {
                        Authorization: `Bearer ${localStorage.getItem("access_token")}`,
                    },
                })
                .then((response) => {
                    let datas = response.data;
                    datas.map((item: any) => {
                        item.date = new Date(item.created_at).toISOString().split('T')[0];
                        item.owner_name = item.owner.name;
                        item.owner_email = item.owner.email;
                        delete item.owner;
                        delete item.created_at;
                        item.action = [
                            {
                                icon: "material-symbols:edit-outline",
                                color: "bg-blue-500",
                                route: `/standarizes/${item.id}`,
                                disabled: !this.isAdmin,
                            },
                            {
                                icon: "material-symbols:cloud-download-outline-rounded",
                                color: "bg-green-500",
                                disabled: item.file_path ? false : true,
                                callback: 'download-file',
                            },
                            {
                                icon: "material-symbols:delete-outline-rounded",
                                color: "bg-red-500",
                                disabled: !this.isAdmin,
                                callback: 'delete-file',
                            },
                        ];
                        delete item.file_path;
                    });
                    this.files = datas;
                })
                .catch((error) => {
                    console.log(error);
                    const detail = error.response.data.detail;
                    let message = "";
                    if (detail[0].msg) {
                        message = detail[0].msg;
                    } else {
                        message = detail;
                    }
                    toastStore.showToast(message, 'danger');
                }).finally(() => {
                    this.isLoading = false;
                })
        },
        search(query: string) {
            this.fetchData(query);
        },
        sortDataBy(head: any) {
            const sortMode = head.sort === '' ? 'asc' : head.sort === 'asc' ? 'desc' : 'asc';
            this.heads = this.heads.map(item => {
                if (item.key !== undefined && item.key === head.key) {
                    item.sort = sortMode;
                    return item;
                }
                return item; // Return the item even if the condition is not met
            }).filter(item => item !== undefined); // Filter out undefined elements

            this.files = this.sortByKey(head.key, this.files, sortMode);
        },
        sortByKey<T>(key: keyof T, array: T[], sortMode: 'asc' | 'desc' | '' = 'asc'): T[] {
            return array.slice().sort((a, b) => {
                const valueA = a[key];
                const valueB = b[key];

                let result: number;

                if (sortMode === 'asc') {
                    result = valueA < valueB ? -1 : valueA > valueB ? 1 : 0;
                } else if (sortMode === 'desc') {
                    result = valueA > valueB ? -1 : valueA < valueB ? 1 : 0;
                } else {
                    // Default to ascending if sortMode is not 'asc' or 'desc'
                    result = valueA < valueB ? -1 : valueA > valueB ? 1 : 0;
                }

                return result;
            });
        },
        async downloadFile(id: number) {
            const toastStore = useToastStore();
            try {
                const response = await this.$api.get(`/standarize/download/${id}`, {
                    headers: {
                        Authorization: `Bearer ${localStorage.getItem('access_token')}`,
                    },
                    responseType: 'blob', // Important to handle binary data like a PDF
                });

                const url = window.URL.createObjectURL(new Blob([response.data]));
                const link = document.createElement('a');
                link.href = url;
                link.setAttribute('download', 'downloaded_file.pdf');
                document.body.appendChild(link);
                link.click();
                document.body.removeChild(link);
            } catch (error: any) {
                console.error('Error downloading PDF:', error);
                if (error.response.status == 404)
                    toastStore.showToast('File tidak ditemukan!', 'danger');
                else
                    toastStore.showToast(error.response.data.detail, 'danger');
            }
        },
        pageUpdate(page: number) {
            this.currentPage = page;
            this.fetchData();
        },
        deleteFile(id: number) {
            // Add your logic for deleting a file
            console.log('delete')
            console.log(id)
            this.isLoading = true;
            const toastStore = useToastStore();
            this.$api.delete(`/standarize/${id}`, {
                headers: {
                    Authorization: `Bearer ${localStorage.getItem("access_token")}`,
                },
            })
                .then((response) => {
                    console.log(response)
                    let title = response.data.title;
                    this.isLoading = false;
                    this.fetchData();
                    toastStore.showToast(`Dokumen ${title} telah dihapus`, 'success');
                })
                .catch((error) => {
                    console.log(error);
                    const detail = error.response.data.detail;
                    let message = "";
                    if (detail[0].msg) {
                        message = detail[0].msg;
                    } else {
                        message = detail;
                    }
                    this.isLoading = false;
                    this.fetchData();
                    toastStore.showToast(message, 'danger');
                })
        },
    },
};
</script>
